﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private rootdrive As String = "e:\"
	Private btncreatedb As Button
	Private clvdbs As CustomListView
	Private clvdocs As CustomListView
	Private pnb4xbtns As Pane
	Private pnb4xclient As Pane
	Private pnnewdb As Pane
	Private pnswitch As Pane
	Private pnwebbtns As Pane
	Private pnwebclient As Pane
	Private tajson As TextArea
	Private tbtnswitch As ToggleButton
	Private tfnewdb As TextField
	Private wvclient As WebView
	Private btnback As Button
	Private btnforward As Button
	Public jowe,jowv As JavaObject
	Public cdb As couchdb
	Private dirpath As String
	Private outputfile As String
	Private tbtnjson As ToggleButton
	Private clvfields As CustomListView
	Private btnitemdel As Button
	Private ftffieldname As B4XFloatTextField
	Private tacontent As TextArea
	Private btnfieldsupdate As Button
	Private lbldoc As Label
	Private btnaddfield As Button
	Private btnnewdoc As Button
	Private lbldb As Label
	Private btnaddattachment As Button
	Private fchoose As FileChooser
	Private cbxattachments As B4XComboBox
	Private lblrev As Label
	Private ivimagefile As ImageView
	Private devwidth As Int
	Private devheight As Int
	Private lbltitle As Label
	Private dialog As B4XDialog
	Private ftfdocid As B4XFloatTextField
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"CouchDBclient")
	dialog.Initialize(Root)
	dialog.PutAtTop = True
	dialog.BodyTextColor = xui.Color_Blue
	dialog.BackgroundColor = xui.Color_LightGray
	wvclient.LoadUrl("http://localhost:5984/_utils/index.html#login")
	If File.Exists(rootdrive,"couchdb_files") = False Then 
		File.MakeDir(rootdrive,"couchdb_files")
	End If
	dirpath = rootdrive & "couchdb_files"
	outputfile = "output.json"
	cdb.Initialize("127.0.0.1",5984,"admin","admin",dirpath,outputfile)
	tajson.Visible = False
	tfnewdb.Text = ""
	fchoose.Initialize
	fill_clvdbs
End Sub
Private Sub fill_clvdbs
	clvdbs.Clear
	Dim strres As String = cdb.get_all_databases
	If strres = "" Then Return
	Dim lst As List = strres.As(JSON).ToList
	For i = 0 To lst.Size -1
		Dim name As String = lst.Get(i)
		If name.Contains("_users") Then Continue
		If name.Contains("_replicator") Then Continue
		clvdbs.AddTextItem(name,name)
	Next
End Sub
Private Sub clvdbs_ItemClick (Index As Int, Value As Object)
	lbldb.Text = Value
	lbldoc.Text = ""
	ftfdocid.Text = ""
	lblrev.Text = ""
	clvfields.Clear
	tajson.Text = ""
	fill_clvdocs(Value)
	reset_cbxattachments
End Sub
Private Sub clvdbs_ItemLongClick (Index As Int, Value As Object)
	' delete
	Dim dbname As String = Value
	Dim rs As Object = xui.Msgbox2Async("Delete database " & dbname, "Delete", "Yes", "Cancel", "No", Null)
	Wait For (rs) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(dirpath,outputfile)
		cdb.delete_database(dbname)
		fill_clvdbs
		clvdocs.Clear
	Else
		Return
	End If
End Sub
Private Sub btncreatedb_Click
	If tfnewdb.Text <> "" Then
		cdb.create_new_database(tfnewdb.text)
		fill_clvdbs
		tfnewdb.Text = ""
	End If
End Sub
Private Sub fill_clvdocs(dbname As String)
	clvdocs.Clear
	Dim strres As String = cdb.get_all_documents(dbname)
	If strres = "" Then Return
	'Log(strres)
	Dim dbmap As Map = strres.As(JSON).ToMap
	If dbmap.ContainsKey("rows") = False Then Return
	Dim rows As List = dbmap.Get("rows")
	For i = 0 To rows.Size -1
		Dim rmap As Map = rows.Get(i)
		Dim docmap As Map = rmap.Get("doc")
		Dim strclv As String = ""
		Dim id As String
		Dim rev As String = ""
		For Each k As String In docmap.Keys
			If k = "_id" Then
				id = docmap.Get(k)
			End If
			If k = "_rev" Then
				rev = docmap.Get(k)
				rev = rev.SubString2(0,rev.IndexOf("-"))
				strclv = strclv & k & "=" & rev & " "
			Else
				strclv = strclv & k & "=" & docmap.Get(k) & " "
			End If
		Next
		clvdocs.AddTextItem(strclv,dbname & ":" & id)
	Next
End Sub
Private Sub clvdocs_ItemClick (Index As Int, Value As Object)
	Dim strdoc As String = Value
	Dim dbname As String = strdoc.SubString2(0,strdoc.IndexOf(":"))
	Dim docid As String =  strdoc.SubString(strdoc.IndexOf(":")+1)
	lbldoc.Text = docid
	ftfdocid.Text = docid
	fill_clvfields(dbname,docid)
End Sub
Private Sub clvdocs_ItemLongClick (Index As Int, Value As Object)
	' delete
	If lbldoc.Text = "" Or lblrev.Text = "" Then Return
	Dim rs As Object = xui.Msgbox2Async("Delete document " & lbldoc.text, "Delete", "Yes", "Cancel", "No", Null)
	Wait For (rs) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(dirpath,outputfile)
		cdb.delete_document(lbldb.Text,lbldoc.text,lblrev.text)
		fill_clvdbs
		fill_clvdocs(lbldb.Text)
		clvfields.Clear
	Else
		Return
	End If
End Sub
Private Sub fill_clvfields(dbname As String,id As String)
	lblrev.Text = ""
	clvfields.Clear
	Dim strres As String = cdb.get_document(dbname,id)
	If strres = "" Then Return
	fill_tajson(strres)
	Dim fldmap As Map = strres.As(JSON).ToMap
	Dim cnt As Int = 0
	For Each k As String In fldmap.Keys
		If k = "_rev" Then lblrev.Text = fldmap.Get(k)
		Dim pn As Pane = set_clvfields_item(cnt,k,fldmap.Get(k))
		clvfields.Add(pn,cnt)
		cnt = cnt + 1
	Next
	fill_cbxattachments	
End Sub
Private Sub set_clvfields_item(cnt As Int, field As String, content As String) As Pane
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, 1300dip,105dip)
	p.LoadLayout("clvfieldsitem_layout")
	btnitemdel.Tag = cnt
	ftffieldname.Text = field
	tacontent.Text = content
	Return p
End Sub
Private Sub btnaddfield_Click
	tbtnjson.Selected = False
	tajson.Text = ""
	If lbldb.Text = "" Or lbldoc.Text = "" Then Return
	Dim pn As Pane = set_clvfields_item(clvfields.Size,"","")
	clvfields.InsertAt(0,pn,0)
	For i = 0 To clvfields.Size - 1
		clvfields.GetPanel(i).GetView(2).Tag = i
	Next
	clvfields.sv.ScrollViewContentHeight = clvfields.Size*85 + 100dip
End Sub
Private Sub btnitemdel_Click
	Dim btn As Button = Sender
	clvfields.RemoveAt(btn.Tag)
	For i = 0 To clvfields.Size - 1
		clvfields.GetPanel(i).GetView(2).Tag = i
	Next
End Sub
Private Sub fill_tajson(strres As String)
	tajson.Text = ""
	Dim fldmap As Map = strres.As(JSON).ToMap
	tajson.Text = tajson.Text & "{" & CRLF
	Dim cnt As Int = 0
	For Each k As String In fldmap.Keys
		cnt = cnt + 1
		If cnt = fldmap.Size Then
			tajson.Text = tajson.Text & """" &  k & """" & ":" & """" & fldmap.Get(k) & """" & CRLF
		Else
			tajson.Text = tajson.Text & """" &  k & """" & ":" & """" & fldmap.Get(k) & """" & "," & CRLF
		End If
	Next
	tajson.Text = tajson.Text & "}" & CRLF
End Sub
Private Sub btnfieldsupdate_Click
	tbtnjson.Selected = False
	If clvfields.Size < 1 Then Return
	Dim strjson As String = """{"
	For i = 0 To clvfields.Size - 1
		Dim fieldname As String = clvfields.GetPanel(i).GetView(0).GetView(0).Text
		Dim content As String = clvfields.GetPanel(i).GetView(1).Text
		If fieldname = "" Or content = "" Then Return
		If i <> clvfields.Size -1 Then
			If fieldname.Contains("_attachments") Then
				strjson = strjson & fieldname & ":" & content & ","
			Else
				strjson = strjson & """""" & fieldname & """"":""""" & content & """""" & ","
			End If
		Else
			If fieldname.Contains("_attachments") Then
				strjson = strjson & fieldname & ":" & content
			Else
				strjson = strjson & """""" & fieldname & """"":""""" & content & """"""
			End If
		End If
	Next
	strjson = strjson & "}"""
	Dim rs As Object = xui.Msgbox2Async(strjson, "Update", "Yes", "Cancel", "No", Null)
	Wait For (rs) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		File.Delete(dirpath,outputfile)
		Dim dbname As String = lbldb.Text
		Dim id As String = lbldoc.Text
		cdb.update_document(dbname, id,strjson)
		fill_clvdocs(dbname)
		fill_clvfields(dbname,id)
	Else
		Return
	End If
End Sub
Private Sub btnnewdoc_Click
	tbtnjson.Selected = False
	tajson.Text = ""
	lbldoc.Text = ""
	ftfdocid.Text = ""
	If lbldb.Text = "" Then Return
	Dim uuid As String = cdb.get_new_UUID
	lbldoc.text = uuid
	ftfdocid.Text = lbldoc.Text		
	clvfields.Clear
	clvfields.AsView.Visible = True
	btnaddfield_Click
End Sub
Private Sub ftfdocid_EnterPressed
	If ftfdocid.Text <> "" Then
		lbldoc.Text = ftfdocid.text
	Else
		Dim uuid As String = cdb.get_new_UUID
		lbldoc.text = uuid
	End If	
End Sub
Private Sub tbtnjson_SelectedChange(Selected As Boolean)
	If Selected Then
		tajson.Visible = True
		tbtnjson.Text = "Hide JSON"
	Else
		tajson.Visible = False
		tbtnjson.Text = "Show JSON"
	End If
End Sub
Private Sub tbtnswitch_SelectedChange(Selected As Boolean)
	If Selected Then
		pnwebclient.Visible = True
		pnwebbtns.Visible = True
		pnb4xbtns.Visible = False
		pnb4xclient.Visible = False
		tbtnswitch.Text = "Hide webclient"
	Else
		pnwebclient.Visible = False
		pnwebbtns.Visible = False
		pnb4xbtns.Visible = True
		pnb4xclient.Visible = True
		tbtnswitch.Text = "Show webclient"
	End If
End Sub
Private Sub btnforward_Click
	If wvclient.IsInitialized Then
		jowv = wvclient
		jowe = jowv.RunMethod("getEngine",Null)
		jowe.RunMethod("executeScript",Array As Object("history.forward()"))
	End If
End Sub
Private Sub btnback_Click
	If wvclient.IsInitialized Then
		jowv = wvclient
		jowe = jowv.RunMethod("getEngine",Null)
		jowe.RunMethod("executeScript",Array As Object("history.back()"))
	End If
End Sub
Private Sub btnaddattachment_Click
	If lbldb.Text = "" Or lbldoc.Text = "" Or lblrev.Text = "" Then Return
	fchoose.setExtensionFilter("Image", Array As String("*.jpg","*.png"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	cdb.add_image_attachment("-X","PUT",lbldb.text & "/" & lbldoc.text & "/",filename,lblrev.text)
	fill_clvdocs(lbldb.Text)
	fill_clvfields(lbldb.Text,lbldoc.Text)
End Sub
Private Sub fill_cbxattachments
	reset_cbxattachments
	Dim strres As String = cdb.get_document(lbldb.text,lbldoc.text)
	Dim fldmap As Map = strres.As(JSON).ToMap
	If fldmap.ContainsKey("_attachments") = False Then Return
	Dim attmap As Map = fldmap.Get("_attachments")
	Dim lst As List
	lst.Initialize
	For Each k As String In attmap.Keys
		If k.Contains(".jpg") Or k.Contains(".png") Then
			lst.Add(k)
		End If
	Next
	cbxattachments.SetItems(lst)
	cbxattachments.SelectedIndex = -1
End Sub
Private Sub cbxattachments_SelectedIndexChanged (Index As Int)
	Dim filename As String = cbxattachments.SelectedItem
	Log(filename)
	show_attachment(filename)
End Sub
Private Sub show_attachment(fname As String)
	If fname.Contains("\") = False Then Return 	' no path value
	devwidth = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Width
	devheight = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Height
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, devwidth-10dip, devheight-70dip)
	pnl.LoadLayout("imagefile_layout")
	lbltitle.Text = "View: " & fname
	ivimagefile.PreserveRatio = True
	Dim filepath As String = fname.SubString2(0,fname.LastIndexOf("\"))
	Dim filename As String = fname.SubString(fname.LastIndexOf("\")+1)
	'ivimagefile.SetImage(fx.LoadImageSample(filepath,filename,devwidth,pnl.Height))
	ivimagefile.SetImage(fx.LoadImage(filepath,filename))
	Wait For (dialog.ShowCustom(pnl, "OK", "", "")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
	cbxattachments.SelectedIndex = -1
End Sub
Private Sub reset_cbxattachments
	Dim lst As List
	lst.Initialize
	cbxattachments.SetItems(lst)	'empty the list
End Sub

