﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private fx As JFX
	Public cdb_host As String
	Public cdb_port As Int
	Public cdb_user As String
	Public cdb_password As String
	Private sh As Shell
	Private urlhead As String
	Public dirpath As String
	Public outputfile As String
End Sub
Public Sub Initialize(host As String, port As Int, user As String, password As String, dir As String, outfile As String)
	cdb_host = host
	cdb_port = port
	cdb_user = user
	cdb_password = password
	urlhead = "http://" & user & ":" & password & "@" & host & ":" & port & "/"
	dirpath = dir
	outputfile = outfile
End Sub
Public Sub send(cparam As String, cmd As String,strfunc As String, strupd As String)
	Dim sh As Shell
	Dim strparam As String = "/C curl -H ""Content-Type: application/json;charset=utf-8"" " & cparam & " " & _
								cmd & " " & urlhead & strfunc & strupd & " >output.json"
	'Log(strparam)
	Dim args As List = Array(strparam)
	sh.InitializeDoNotHandleQuotes("shl", "cmd.exe", args)
	sh.WorkingDirectory = dirpath
	sh.RunSynchronous(-1)			' the process must complete
End Sub
Public Sub create_new_database(name As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "PUT",name,"")
	Dim strres As String = get_resultstring
	show_response_msg
	Return strres
End Sub
Public Sub delete_database(name As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "DELETE",name,"")
	Dim strres As String = get_resultstring
	show_response_msg
	Return strres
End Sub
Public Sub get_all_databases As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET","_all_dbs","")
	Dim strres As String = get_resultstring
	'show_response_msg
	Return strres
End Sub
Public Sub get_all_documents(dbname As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET",dbname & "/_all_docs?include_docs=true","")
	Dim strres As String = get_resultstring
	'show_response_msg
	Return strres
End Sub
Public Sub get_document(dbname As String, id As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET",dbname & "/" & id,"")
	Dim strres As String = get_resultstring
	'show_response_msg
	Return strres
End Sub
Public Sub get_document_revisions(dbname As String, id As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET",dbname & "/" & id & "?revs_info=true","")
	Dim strres As String = get_resultstring
	'show_response_msg
	Return strres
End Sub
Public Sub get_new_UUID As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET","_uuids","")
	Dim strres As String = get_resultstring
	'show_response_msg
	Dim uumap As Map = strres.As(JSON).ToMap
	Dim uulst As List = uumap.Get("uuids")
	Dim uuid As String = uulst.Get(0)
	Return uuid
End Sub
Public Sub get_resultstring As String
	If File.Exists(dirpath,outputfile) = True Then
		Dim strres As String = File.ReadString(dirpath,outputfile)		' output.json
		Return strres
	Else
		xui.MsgboxAsync("No output file exists!","Output")
		Return ""
	End If
End Sub
Public Sub update_document(dbname As String, id As String,strsource As String)
	File.Delete(dirpath,outputfile)
	Dim strupd As String = " -d " & strsource
	send("-X", "PUT",dbname & "/" & id & "/",strupd)
	show_response_msg
End Sub
Public Sub delete_document(dbname As String, id As String,rev As String)
	File.Delete(dirpath,outputfile)
	Log(dbname & "/" & id & "?rev=" & rev)
	send("-X", "DELETE",dbname & "/" & id & "?rev=" & rev,"")
	show_response_msg
End Sub
Public Sub show_response_msg
	Dim strres As String = File.ReadString(dirpath,outputfile)
	xui.MsgboxAsync(strres,"Response")
End Sub
Public Sub add_image_attachment(cparam As String, cmd As String,strfunc As String,fname As String,rev As String) As String
	Dim sh As Shell
	Dim strparam As String = "/C curl -H ""Content-Type: image/jpg"" " & cparam & " " & _
				cmd & " " & urlhead & strfunc & "/" & fname & "?rev=" & rev & " --data-binary @" & fname & " >output.json"
	Dim args As List = Array(strparam)
	sh.InitializeDoNotHandleQuotes("shl", "cmd.exe", args)
	sh.WorkingDirectory = dirpath
	sh.RunSynchronous(-1)
	Dim strres As String = get_resultstring
	show_response_msg
	Return strres
End Sub
Public Sub get_document_attachments(dbname As String,id As String) As String
	File.Delete(dirpath,outputfile)
	send("-X", "GET",dbname & "/" & id & "?attachments=true","")
	Dim strres As String = get_resultstring
	'show_response_msg
	Return strres
End Sub

